/*
	File:		CardSpecific.h

	Contains:	Definitions and constants which are unique to this PC Card client

	Written by:	Dave Falkenburg

	Copyright  1992-1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <0>	 12/6/95	DRF		Initial edit
*/

#ifndef	_APPLE_CARDSPECIFIC_
#define	_APPLE_CARDSPECIFIC_

#include "STNIC.h"

enum
	{
	kMyClientVersion 			=	0x0100,		//	driver version, in BCD
	kRequiredCSLevel			=	0x0210,		//	card services release compliance, in BCD
	kMyClientRevisionDate		=	((1995-1980)<<9) | (12<<5) | (6<<0),	//	December 6th, 1995 (y/m/d)

	//	These values are associated with the IBM 10BaseT Ethernet PC Card

	kMyTPLMID_MANF				=	0xA400,		// PCMCIA PC Card manufacturer code
	kMyTPLMID_CARD				=	0x0200,		// manufacturer information (part number and/or revision)


	kPCCardClientAttributes		=	(kCSIOClient | kCSShareableCardInsertEvents),

	kInterestingPCCardEvents =
		(kCSEjectRequestEvent | kCSReadyChangeEvent | kCSCardDetectChangeEvent |
		kCSPMChangeEvent | kCSResetEvent | kCSFunctionInterrupt)
	};


struct	PCCardPerSocketState
	{
	UInt32		cardFlags;		//	must be present in structure

	UInt8		ethernetAddress[6];
	STNICReg *	ioBase;
	void *		memBase;

	UInt32		ioWindowHandle;
	UInt32		memWindowHandle;
	};

#endif
