/*
	File:		SystemSoft.h

	Contains:	SystemSoft modifications to Display Name Registry
	
	Written by: Dave Tarabar

	Copyright  1996 SystemSoft Corp. All rights reserved.
	
	Change History (most recent first):

*/

#ifndef __SYSTEMSOFT_H__
#define __SYSTEMSOFT_H__

#include <DiskInit.h>

// this flag is used to condition the SYSF changes

#define SYSF 1

// no need to print out long binary dumps (like driver code) so we will limit
// the number of lines in a hex dump

#define	kMaxLinesToPrint	10

// we only care about PC card related name registry entries
// they begin with the following prefix

#define WECARE "Devices:device-tree:bandit:ti1130"
// for roms previous to D18
#define WECARED "Devices:device-tree:bandit:pci104c"
// on the 9500
//#define WECARE "Devices:device-tree:bandit:pci"

// prefix for the first PC Card RegEntry
#define WECARECARD "Devices:device-tree:bandit:ti1130:"

// define custom AppleEvents defined in the kAEMiscStandards event class

enum {
	 kDevRegSnapshot	=	'Snap'	,
	 kDevRegRescan		=	'ReSc'	,
	 kDevRegNoSockets	=	'NoSk'
};

#endif /* __SYSTEMSOFT_H__ */